# -*- coding: utf-8 -*-

from rdflib.graph import Graph, ConjunctiveGraph, ReadOnlyGraphAggregate
from rdflib.term import BNode
import hashlib
import sys
import urllib

try:
    owl_url = sys.argv[1]
    rdfa_url = sys.argv[2]
    try:
        owl_compare = sys.argv[3]
    except IndexError:
        owl_compare = "fileowl.nt"
    try:
        rdfa_compare = sys.argv[4]
    except IndexError:
        rdfa_compare = "filerdfa.nt"
except IndexError:
    print "Enter two URLs"
    print "comp.py http://example.org/one.owl http://example.com/two.html [fileowl.nt] [filerdfa.nt]"
    sys.exit(2)

try:
    urllib.urlopen(owl_url)
    urllib.urlopen(rdfa_url)
except IOError:
    print "Not a real URL"
    print "comp.py http://example.org/one.owl http://example.com/two.n3 [fileowl.nt] [filerdfa.nt]"
    sys.exit(2)

g1 = Graph().parse(owl_url, format='xml')
g2 = Graph().parse(rdfa_url, format='n3')


#OWL - RDF/XML to N-Triples
file = open(owl_compare, 'w')
for l in sorted(g1.serialize(format='nt').splitlines()):
    if l:
        file.write(l)
        file.write("\n")
file.close()

#N3 to N-Triples
file = open(rdfa_compare, 'w')
for l in sorted(g2.serialize(format='nt').splitlines()):
    if l:
        file.write(l)
        file.write("\n")
file.close()


print "SHA224 of N-Triples from XML/RDF:"
owl_nt = open(owl_compare, 'r').read()
owl_hash = hashlib.sha224(owl_nt).hexdigest()
file.close()
print owl_hash

print "\nSHA224 of N-Triples from N3:"
rdfa_nt = open(rdfa_compare, 'r').read()
rdfa_hash = hashlib.sha224(rdfa_nt).hexdigest()
file.close()
print rdfa_hash

if owl_hash == rdfa_hash:
    print "\nVocabularies are the same"
else:
    print "\nVocabularies are NOT the same"
